//`define box 5'd9
//
//module Rasterizer(clk, reset, x1, y1, x2, y2, x3, y3, pixelOut, out_pixel_x, out_pixel_y, stall, done);
//
//input clk;
//input reset;
//input stall;
//
//input wire signed[8:0] x1, x2, x3, y1, y2, y3;
//
//output wire pixelOut;
//assign pixelOut = (reset & ~done) | (state == 5'd7 && ((p3[17] == 0 && c3[17] == 1 && p3 > -c3) || (p3[17] == 0 && c3[17] == 0) || (p3[17] == 1 && c3[17] == 0 && c3 > -p3) || (p3[17] != c3[17] && p3 == -c3)));
//
//output [9:0] out_pixel_x;
//output [9:0] out_pixel_y;
//
//reg [4:0] state;
//output reg done;
//reg [17:0] c1, c2, c3;
//reg [4:0] i,j;
//reg [17:0] p1, p2, p3;
//
//parameter exit = 5'd15;
//
//wire signed[17:0] wire1, wire2, wire3;
//wire signed [8:0] in1a, in1b, in2a, in2b;
//
//wire [8:0] xmin, ymin;
//assign xmin = (x1 <= x2 & x1 <= x3) ? x1 : (x2 <= x1 & x2 <= x3) ? x2 : x3;
//assign ymin = (y1 <= y2 & y1 <= y3) ? y1 : (y2 <= y1 & y2 <= y3) ? y2 : y3;
//
//assign in1a = 	(state == 5'd1 || state == 5'd4) ? (y1-y2) : 
//				(state == 5'd2 || state == 5'd5) ? (y3-y1) : 
//				(state == 5'd3 || state == 5'd6) ? (y2-y3) : 0;
//				
//assign in1b = 	(state == 5'd1 ) ? x1-xmin : 
//				(state == 5'd2 ) ? x3-xmin : 
//				(state == 5'd3 ) ? x2-xmin : 
//				(state == 5'd4 ) ? i  :
//				(state == 5'd5 ) ? i  :
//				(state == 5'd6 ) ? i  : 0;
//				
//assign in2a = 	(state == 5'd1 || state == 5'd4) ? (x1-x2) : 
//				(state == 5'd2 || state == 5'd5) ? (x3-x1) : 
//				(state == 5'd3 || state == 5'd6) ? (x2-x3) : 0;
//								
//assign in2b = 	(state == 5'd1 ) ? y1-ymin : 
//				(state == 5'd2 ) ? y3-ymin : 
//				(state == 5'd3 ) ? y2-ymin : 
//				(state == 5'd4 ) ? j  :
//				(state == 5'd5 ) ? j  :
//				(state == 5'd6 ) ? j  : 0;
//
//
//signed_mult_2 mult2(.a(in1a), .b(in1b), .out(wire1));
//signed_mult_2 mult3(.a(in2a), .b(in2b), .out(wire2));
//
//
//assign wire3 = wire1 - wire2;
//
//assign out_pixel_x = xmin + i;
//assign out_pixel_y = 240 - (ymin + j);
//
///* Note: vertice inputs are normalized to bounding box, where (0,0) is
//bottom left corner*/
//always@(posedge clk) begin
//if (stall)
//	begin
//		i <= i;
//        j <= j;
//        c1 <= c1;
//        c2 <= c2;
//        c3 <= c3;
//        state <= state;
//        p1 <= p1;
//        p2 <= p2;
//        p3 <= p3;
//        
//        done <= done;
//	end
//else
//begin
//if(reset) begin
//	state <= 5'd0;
//	i <= 5'd0;
//	j <= 5'd0;
//	done <= 1'b0;
//end
//else begin
//    /* Go through each pixel and compare to the three equations */
//    case(state)
//        0:
//        begin
//            i <= 0;
//            j <= 0;
//            c1 <= 0;
//            c2 <= 0;
//            c3 <= 0;
//            p1 <= 0;
//            p2 <= 0;
//            p3 <= 0;
//            done <= 1'b0;
//            state <= 5'd1;
//        end
//        1:
//        begin
//            c1 <= -wire3; /*(y1-y2)*x1 - (x1-x2)*y1;*/
//            state <= 5'd2;
//        end
//        2:
//        begin
//            c2 <= -wire3; //(y3-y1)*x3 - (x3-x1)*y3;
//            state <= 5'd3;
//        end
//        3:
//        begin
//            c3 <= -wire3; //(y2-y3)*x2 - (x2-x3)*y2;
//            state <= 5'd4;
//        end
//        4:
//        begin
//			p1 <= wire3; //(y1-y2)*i - (x1-x2)*j;
//			state <= 5'd5;
//			//pixelOut <= 1'b0;
//		end
//        5:
//        begin
//			if( (p1[17] == 0 && c1[17] == 1 && p1 > -c1) || (p1[17] == 0 && c1[17] == 0) || (p1[17] == 1 && c1[17] == 0 && c1 > -p1) || (p1[17] != c1[17] && p1 == -c1)) begin
//                state <= 5'd6;
//                p2 <= wire3; //(y3-y1)*i - (x3-x1)*j;
//            end
//            else begin
//            //pixelOut <= 1'b0;
//				if(i == 5'd9 && j == 5'd9)
//					state <= exit;
//                else begin
//					if(i < 5'd9)
//						i <= i + 5'd1;
//					else begin
//						j <= j + 5'd1;
//						i <= 5'd0;
//					end
//					state <= 5'd4;
//				end
//			end
//        end
//        6:
//        begin
//            if( (p2[17] == 0 && c2[17] == 1 && p2 > -c2) || (p2[17] == 0 && c2[17] == 0) || (p2[17] == 1 && c2[17] == 0 && c2 > -p2) || (p2[17] != c2[17] && p2 == -c2))
//            begin
//				p3 <= wire3; //(y2-y3)*i - (x2-x3)*j;
//                state <= 5'd7;
//            end
//            else begin
//            //pixelOut <= 1'b0;
//				if(i == 5'd9 && j == 5'd9)
//					state <= exit;
//                else begin
//					if(i < 5'd9)
//						i <= i + 5'd1;
//					else begin
//						j <= j + 5'd1;
//						i <= 5'd0;
//					end
//					state <= 5'd4;
//				end
//			end
//        end
//        7:
//        begin
////            if( p3[16:0] > c3[16:0] )
////                pixelOut <= 1'b1;
////            else
////                pixelOut <= 1'b0;
//
//			if(i == 5'd9 && j == 5'd9)
//				state <= exit;
//            else begin
//				if(i < 5'd9)
//					i <= i + 5'd1;
//				else begin
//					j <= j + 5'd1;
//					i <= 5'd0;
//				end
//				state <= 5'd4;
//			end
//		end
//        exit:
//        begin
//            done <= 1'b1;
//            //state <= 5'd0;
//            //i <= 5'd0;
//            //j <= 5'd0;
//        end
//	endcase
//end //else
//end //else
//end //always
//
//endmodule
//
//
//////// NEED TO PASS A WRITE ENABLE OUT FOR THE SRAM
////
////
////module Rasterizer	(
////						clock,
////						reset,
////						
////						vertex1_x,
////						vertex1_y, 
////						
////						vertex2_x, 
////						vertex2_y, 
////						
////						vertex3_x, 
////						vertex3_y, 
////						
////						out_fragment_x, 
////						out_fragment_y, 
////						fragment_c,
////						
////						stallOUT,
////						stallIN,
////						
////						out
////					);
////			
////output [26:0] out;
////wire [26:0] out;
////
////assign out = fragment_x;
////					
////input clock;
////input reset;
////
////input signed[26:0] vertex1_x;
////input signed[26:0] vertex1_y;
////
////input signed[26:0] vertex2_x;
////input signed[26:0] vertex2_y;
////
////input signed[26:0] vertex3_x;
////input signed[26:0] vertex3_y;
////
////output [9:0] out_fragment_x;
////output [9:0] out_fragment_y;
////output [15:0] fragment_c;
////
////wire [9:0] out_fragment_x;
////wire [9:0] out_fragment_y;
////
////assign out_fragment_x = {2'b00, fragment_x[26:19]};
////assign out_fragment_y = {2'b00, fragment_y[26:19]};
////
////reg signed[26:0] fragment_x;
////reg signed[26:0] fragment_y;
////reg signed[15:0] fragment_c;
////
////input stallIN;
////wire stallIN;
////
////output stallOUT;
////reg stallOUT;
////
////reg [1:0] setup_counter;
////
////reg signed[26:0] xMin, xMax;
////reg signed[26:0] yMin, yMax;
////
////wire signed [26:0] r_minus_r3_x, r_minus_r3_y;
////
////wire signed [26:0] x1_x3, x2_x3, y1_y3, y2_y3;
////
////wire signed [26:0] det1, det2;
////reg signed [26:0] det;
////
////wire signed [26:0] lambda1, lambda2, lambda3;
////
////wire signed [26:0] a,b,d,e;
////reg signed [26:0] c,f;
////
////assign r_minus_r3_x = (fragment_x - vertex3_x) ;
////assign r_minus_r3_y = (fragment_y - vertex3_y) ;
////
////assign x1_x3 = (vertex1_x - vertex3_x) ;
////assign x2_x3 = (vertex2_x - vertex3_x) ;
////
////assign y1_y3 = (vertex1_y - vertex3_y) ;
////assign y2_y3 = (vertex2_y - vertex3_y) ;
////
////signed_mult_8 s1(det1, x1_x3, y2_y3);
////signed_mult_8 s2(det2, x2_x3, y1_y3);
////
////signed_mult_8 s3(a, y2_y3, r_minus_r3_x);
////signed_mult_8 s4(b, x2_x3, r_minus_r3_y);
////
////signed_mult_8 s5(d, y1_y3, r_minus_r3_x);
////signed_mult_8 s6(e, x1_x3, r_minus_r3_y);
////
////signed_mult_8 s7(lambda1, c, 27'b100000000000001100000000000);//27'b000000010000000000000000000 / det);
////signed_mult_8 s8(lambda2, f, 27'b100000000000001100000000000);//27'b000000010000000000000000000 / det);
////
////assign lambda3 = 27'b000000010000000000000000000 - lambda1 - lambda2;
////
////always @(posedge clock)
////begin
////	if (reset)
////	begin
////		stallOUT <= 1'b0;
////		
////		fragment_x <= 27'd0;
////		fragment_y <= 27'd0;
////		fragment_c <= 16'b0;
////		
////		xMin <= 10'b0;
////		xMax <= 10'b0;
////		
////		yMin <= 10'b0;
////		yMax <= 10'b0;
////		
////		setup_counter <= 2'b00;
////		
////		det <= 0;
////		c <= 0;
////		f <= 0;
////	end
////	
////	else if (stallOUT & !stallIN)
////	begin
////		if (setup_counter == 2'b00)
////		begin
////			det <= det1 - det2;
////			
////			c <= a - b;
////			f <= e - d;
////		
////			setup_counter <= 2'b01;
////		end
////		
////		else
////		begin
////			c <= c;
////			f <= f;
////			det <= det;
////			
////			setup_counter <= 2'b00;
////	
////			if (fragment_y <= yMax)
////			begin
////				if (fragment_x < xMax)
////				begin
////					fragment_x <= fragment_x + 27'b000000010000000000000000000;
////					fragment_y <= fragment_y;
////				end
////				
////				else
////				begin
////					fragment_y <= fragment_y + 27'b000000010000000000000000000;
////					fragment_x <= xMin;
////				end
////				
////				if (lambda1 > 0 & lambda2 > 0 & lambda3 > 0)
////					fragment_c <= 16'b0000000000111111;
////				else
////				//HERE WE NEED TO PASS OUT NOT TO WRITE TO SRAM
////					fragment_c <= 16'b0;
////					
////				stallOUT <= 1'b1;
////						
////				xMin <= xMin;
////				xMax <= xMax;
////			
////				yMin <= yMin;
////				yMax <= yMax;
////			end
////			
////			else
////			begin
////				//HERE WE NEED TO PASS OUT NOT TO WRITE TO SRAM
////				stallOUT <= 1'b0;
////				
////				fragment_x <= fragment_x;
////				fragment_y <= fragment_y;
////				fragment_c <= 16'b0;
////		
////				xMin <= xMin;
////				xMax <= xMax;
////		
////				yMin <= yMin;
////				yMax <= yMax;
////			end
////		end
////	end
////	
////	else if (stallOUT & stallIN)
////	begin
////		stallOUT <= stallOUT;
////		fragment_x <= fragment_x;
////		fragment_y <= fragment_y;
////		fragment_c <= fragment_c;
////		
////		xMin <= xMin;
////		xMax <= xMax;
////		
////		yMin <= yMin;
////		yMax <= yMax;
////		
////		setup_counter <= setup_counter;
////		
////		c <= c;
////		f <= f;
////		det <= det;
////	end
////	
////	//eventually do culling test here
////	//for now do every triangle
////	//need to set up to start incrementing here
////	else
////	begin
////	// CAN ACTUALLY DO THIS AS COMBINATORIAL LOGIC TO SAVE A CYCLE
////	
////	
////		//xmax
////		if (vertex1_x > vertex2_x & vertex1_x > vertex3_x)
////		begin
////			xMax <= vertex1_x;
////			
////		end
////		
////		else if (vertex2_x > vertex1_x & vertex2_x > vertex3_x)
////		begin
////			xMax <= vertex2_x;
////			
////		end
////		else
////		begin
////			xMax <= vertex3_x;
////			
////		end
////		
////		//xmin	
////		if (vertex1_x < vertex2_x & vertex1_x < vertex3_x)
////		begin
////			xMin <= vertex1_x;
////			fragment_x <= vertex1_x;
////		end
////		
////		else if (vertex2_x < vertex1_x & vertex2_x < vertex3_x)
////		begin
////			xMin <= vertex2_x;
////			fragment_x <= vertex2_x;
////			
////		end
////		
////		else
////		begin
////			xMin <= vertex3_x;
////			fragment_x <= vertex3_x;
////		end
////		
////		//ymax
////		if (vertex1_y > vertex2_y & vertex1_y > vertex3_y)
////		begin
////			yMax <= vertex1_y;
////			
////		end
////		
////		else if (vertex2_y > vertex1_y & vertex2_y > vertex3_y)
////		begin
////			yMax <= vertex2_y;
////			
////		end
////
////		else
////		begin
////			yMax <= vertex3_y;
////			
////		end
////		
////		//ymin
////		if (vertex1_y < vertex2_y & vertex1_y < vertex3_y)
////		begin
////			yMin <= vertex1_y;
////			fragment_y <= vertex1_y;
////		end
////		
////		else if (vertex2_y < vertex1_y & vertex2_y < vertex3_y)
////		begin
////			yMin <= vertex2_y;
////			fragment_y <= vertex2_y;
////		end
////		
////		else
////		begin
////			yMin <= vertex3_y;
////			fragment_y <= vertex3_y;
////		end
////		
////		/////CULL TRIANGLES
////		
////		//if (det < 0)
////		//	stallOUT <= 1'b0;
////		//else
////		//	stallOUT <= 1'b1;
////		
////		fragment_c <= 16'b0000000000111111;
////		
////		setup_counter <= 2'b00;
////		
////		stallOUT <= 1'b1;
////	end
////end
////
////endmodule
////
////
////////// NEED TO PASS A WRITE ENABLE OUT FOR THE SRAM
//////
//////
//////module Rasterizer	(
//////						clock,
//////						reset,
//////						
//////						vertex1_x,
//////						vertex1_y, 
////////						vertex1_c, 
//////						
//////						vertex2_x, 
//////						vertex2_y, 
////////						vertex3_c, 
//////						
//////						vertex3_x, 
//////						vertex3_y, 
////////						vertex3_c, 
//////						
//////						fragment_x, 
//////						fragment_y, 
//////						fragment_c,
//////						
//////						stallOUT,
//////						stallIN,
//////						out
//////					);
//////					
//////output [17:0] out;
//////wire [17:0] out;
//////
//////input clock;
//////input reset;
//////
//////input [9:0] vertex1_x;
//////input [9:0] vertex1_y;
////////input [15:0] vertex1_c;
//////
//////input [9:0] vertex2_x;
//////input [9:0] vertex2_y;
////////input [15:0] vertex2_c;
//////
//////input [9:0] vertex3_x;
//////input [9:0] vertex3_y;
////////input [15:0] vertex3_c;
//////
//////output [9:0] fragment_x;
//////output [9:0] fragment_y;
//////output [15:0] fragment_c;
//////
//////reg [9:0] fragment_x;
//////reg [9:0] fragment_y;
//////reg [15:0] fragment_c;
//////
//////input stallIN;
//////wire stallIN;
//////
//////output stallOUT;
//////reg stallOUT;
//////
//////reg [9:0] xMin, xMax;
//////reg [9:0] yMin, yMax;
//////
//////reg [1:0] setup_counter;
//////
//////wire signed [10:0] r_minus_r3_x, r_minus_r3_y;
//////
//////assign r_minus_r3_x = fragment_x - vertex3_x;
//////assign r_minus_r3_y = fragment_y - vertex3_y;
//////
//////wire signed [10:0] x1_x3, x2_x3, y1_y3, y2_y3;
//////
//////assign x1_x3 = vertex1_x - vertex3_x;
//////assign x2_x3 = vertex2_x - vertex3_x;
//////
//////assign y1_y3 = vertex1_y - vertex3_y;
//////assign y2_y3 = vertex2_y - vertex3_y;
//////
////////wire signed[17:0] det1, det2;
////////reg signed[17:0] det;
//////
////////assign det1 = x1_x3 * y2_y3;
////////assign det2 = x2_x3 * y1_y3;
//////
//////wire signed [17:0] lambda1, lambda2;
//////reg signed[17:0] lambda3;
//////
//////wire signed [10:0] a,b,d,e;
//////reg signed [10:0] c,f;
//////
//////wire [17:0] clamb, flamb;
//////
//////assign a = y2_y3 * r_minus_r3_x;
//////assign b = x2_x3 * r_minus_r3_y;
//////
//////assign d = y1_y3 * r_minus_r3_x;
//////assign e = x1_x3 * r_minus_r3_y;
//////
//////
//////wire [17:0] lamb1, sub1, sub2, sub3;
//////
//////assign lamb1 = 18'b101110111101001000;
//////
////////int2fp (lamb1, 10'b1101001000, 8'b1110111);
//////int2fp (clamb, c, 0);
//////int2fp (flamb, f, 0);
//////
//////int2fp (sub2, 1, 0);
//////
//////fpmult f1 (lambda1, clamb, lamb1);
//////fpmult f2 (lambda2, flamb, lamb1);
//////
//////fpadd a1(sub1, sub2, {~lambda1[17],lambda1[16:0]});
////////fpadd a2(sub3, lambda3, {~lambda2[17],lambda2[16:0]});
//////
//////assign out = flamb;
//////
//////always @(posedge clock)
//////begin
//////	if (reset)
//////	begin
//////		stallOUT <= 1'b0;
//////		
//////		fragment_x <= 10'd0;
//////		fragment_y <= 10'd0;
//////		fragment_c <= 16'b0;
//////		
//////		xMin <= 10'b0;
//////		xMax <= 10'b0;
//////		
//////		yMin <= 10'b0;
//////		yMax <= 10'b0;
//////		
//////		setup_counter <= 2'b00;
//////	end
//////	
//////	else if (stallOUT & !stallIN)
//////	begin
//////		if (fragment_y < yMax)
//////		begin
//////			if (fragment_x < xMax)
//////			begin
//////				stallOUT <= 1'b1;
//////				
//////				fragment_x <= fragment_x + 10'd1;
//////				fragment_y <= fragment_y;
//////		
//////				xMin <= xMin;
//////				xMax <= xMax;
//////		
//////				yMin <= yMin;
//////				yMax <= yMax;
//////				
//////				if (lambda1[17] == 0 & lambda2[17] == 0 & lambda3[17] == 0)
//////					fragment_c <= 16'b0000000000111111;
//////				else
//////					fragment_c <= 16'b0;
//////			end
//////			
//////			else
//////			begin
//////				fragment_y <= fragment_y + 1'b1;
//////				fragment_x <= xMin;
//////				fragment_c <= fragment_c;
//////				
//////				stallOUT <= 1'b1;
//////				
//////				xMin <= xMin;
//////				xMax <= xMax;
//////		
//////				yMin <= yMin;
//////				yMax <= yMax;
//////				
//////			end
//////		end
//////		
//////		else
//////		begin
//////			stallOUT <= 1'b0;
//////			
//////			fragment_x <= fragment_x;
//////			fragment_y <= fragment_y;
//////			fragment_c <= 16'b0;
//////		
//////			xMin <= xMin;
//////			xMax <= xMax;
//////		
//////			yMin <= yMin;
//////			yMax <= yMax;
//////		end
//////	end
//////	
//////	else if (stallOUT & stallIN)
//////	begin
//////		stallOUT <= stallOUT;
//////		fragment_x <= fragment_x;
//////		fragment_y <= fragment_y;
//////		fragment_c <= fragment_c;
//////		
//////		xMin <= xMin;
//////		xMax <= xMax;
//////		
//////		yMin <= yMin;
//////		yMax <= yMax;
//////	end
//////	
//////	//eventually do culling test here
//////	//for now do every triangle
//////	//need to set up to start incrementing here
//////	else
//////	begin
//////	if (setup_counter == 2'b00)
//////	begin
//////		//xmax
//////		if (vertex1_x > vertex2_x & vertex1_x > vertex3_x)
//////			xMax <= vertex1_x;
//////		
//////		else if (vertex2_x > vertex1_x & vertex2_x > vertex3_x)
//////			xMax <= vertex2_x;
//////			
//////		else
//////			xMax <= vertex3_x;
//////		
//////		//xmin	
//////		if (vertex1_x < vertex2_x & vertex1_x < vertex3_x)
//////		begin
//////			xMin <= vertex1_x;
//////			fragment_x <= vertex1_x;
//////		end
//////		
//////		else if (vertex2_x < vertex1_x & vertex2_x < vertex3_x)
//////		begin
//////			xMin <= vertex2_x;
//////			fragment_x <= vertex2_x;
//////		end
//////		
//////		else
//////		begin
//////			xMin <= vertex3_x;
//////			fragment_x <= vertex3_x;
//////		end
//////		
//////		//ymax
//////		if (vertex1_y > vertex2_y & vertex1_y > vertex3_y)
//////			yMax <= vertex1_y;
//////		
//////		else if (vertex2_y > vertex1_y & vertex2_y > vertex3_y)
//////			yMax <= vertex2_y;
//////
//////		else
//////			yMax <= vertex3_y;
//////		
//////		//ymin
//////		if (vertex1_y < vertex2_y & vertex1_y < vertex3_y)
//////		begin
//////			yMin <= vertex1_y;
//////			fragment_y <= vertex1_y;
//////		end
//////		
//////		else if (vertex2_y < vertex1_y & vertex2_y < vertex3_y)
//////		begin
//////			yMin <= vertex2_y;
//////			fragment_y <= vertex2_y;
//////		end
//////		
//////		else
//////		begin
//////			yMin <= vertex3_y;
//////			fragment_y <= vertex3_y;
//////		end
//////		
//////		//if (det < 0)
//////		//	stallOUT <= 1'b0;
//////		//else
//////		//	stallOUT <= 1'b1;
//////		
//////		fragment_c <= 16'b0000000000111111;
//////		
//////		setup_counter <= 2'b01;
//////	end
//////	else if (setup_counter == 2'b01)
//////	begin
//////		//det <= det1 - det2;
//////		c <= a - b;
//////		f <= e - d;
//////		
//////		setup_counter <= 2'b10;
//////	end
//////	
//////	else if (setup_counter == 2'b10)
//////	begin
//////		lambda3 <= sub1;		
//////		setup_counter <= 2'b11;
//////	end
//////	
//////	else
//////	begin
//////		//lambda3 <= sub3;
//////		stallOUT <= 1'b1;
//////		setup_counter <= 2'b00;
//////	end
//////	end
//////end
//////
//////endmodule
